package across.agents.location;

import across.data.Weather;

/**
 * This class represents the simulation data of a location - the simulation data are the 
 * data that exist in some way in the simulation world.
 * @author Eduard Semsch
 *
 */
public class LocationAgentSimulationData {
	
	/** Contains tribe of this location agent */
	protected String tribe = null;
	
	/** Contains region of this location agent */
	protected String region = null;
	
	/** Contains current simulation time as received from weather agent.*/
	protected long simTime = 0;
	
	/** Weather in area */
	protected Weather weather;
	
	/** Seconds for one consumation/allocation period */
	protected int secondsPerDay;
	
	/** The actual size of the location */
	protected double locVicinity;

	
}
